import "core-js/modules/es6.object.assign";
import "core-js/modules/web.dom.iterable";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { render } from 'enzyme';
import { requiredProps } from '../../test/required_props';
import { EuiIcon, SIZES, TYPES, COLORS } from './icon';
describe('EuiIcon', function () {
  test('is rendered', function () {
    var component = render(React.createElement(EuiIcon, _extends({
      type: "search"
    }, requiredProps)));
    expect(component).toMatchSnapshot();
  });
  describe('props', function () {
    describe('other props', function () {
      test('are passed through to the icon', function () {
        var component = render(React.createElement(EuiIcon, {
          type: "search",
          "aria-label": "a custom title"
        }));
        expect(component).toMatchSnapshot();
      });
    });
    describe('size', function () {
      SIZES.forEach(function (size) {
        test("".concat(size, " is rendered"), function () {
          var component = render(React.createElement(EuiIcon, {
            type: "search",
            size: size
          }));
          expect(component).toMatchSnapshot();
        });
      });
    });
    describe('type', function () {
      TYPES.forEach(function (type) {
        test("".concat(type, " is rendered"), function () {
          var component = render(React.createElement(EuiIcon, {
            type: type
          }));
          expect(component).toMatchSnapshot();
        });
      });
    });
    describe('color', function () {
      COLORS.concat(['#fde', '#885522', 'rgb(100, 150, 200)', 'hsla(270, 60%, 70%, 0.9)']).forEach(function (color) {
        test("".concat(color, " is rendered"), function () {
          var component = render(React.createElement(EuiIcon, {
            color: color
          }));
          expect(component).toMatchSnapshot();
        });
      });
    });
    describe('tabIndex', function () {
      test('renders focusable="false" when not provided', function () {
        var component = render(React.createElement(EuiIcon, {
          type: "search"
        }));
        expect(component).toMatchSnapshot();
      });
      test('renders focusable="false" when -1', function () {
        var component = render(React.createElement(EuiIcon, {
          type: "search",
          tabIndex: -1
        }));
        expect(component).toMatchSnapshot();
      });
      test('renders focusable="true" when 0', function () {
        var component = render(React.createElement(EuiIcon, {
          type: "search",
          tabIndex: 0
        }));
        expect(component).toMatchSnapshot();
      });
    });
  });
});