import "core-js/modules/es6.array.sort";
import "core-js/modules/es6.regexp.split";
import "core-js/modules/es7.array.includes";
import "core-js/modules/es6.string.includes";

/**
 * Secures outbound links. For more info:
 * https://www.jitbit.com/alexblog/256-targetblank---the-most-underestimated-vulnerability-ever/
 */
import filter from 'lodash/filter';
import { isDomainSecure } from '../url';
export var getSecureRelForTarget = function getSecureRelForTarget(_ref) {
  var href = _ref.href,
      target = _ref.target,
      rel = _ref.rel;

  if (!target || !target.includes('_blank')) {
    return rel;
  }

  var isElasticHref = !!href && isDomainSecure(href);
  var relParts = !!rel ? filter(rel.split(' '), function (part) {
    return !!part.length && part !== 'noreferrer';
  }) : [];

  if (relParts.indexOf('noopener') === -1) {
    relParts.push('noopener');
  }

  if (!isElasticHref) {
    relParts.push('noreferrer');
  }

  return relParts.sort().join(' ').trim();
};