"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiColorPickerSwatch = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _color_picker_empty_swatch = require("./color_picker_empty_swatch");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var EuiColorPickerSwatch = function EuiColorPickerSwatch(_ref) {
  var color = _ref.color,
      className = _ref.className,
      rest = _objectWithoutProperties(_ref, ["color", "className"]);

  var isClear = !color;
  var classes = (0, _classnames.default)('euiColorPicker__swatch', className, {
    euiColorPicker__emptySwatch: isClear
  });
  var children;

  if (isClear) {
    children = _react.default.createElement(_color_picker_empty_swatch.EuiColorPickerEmptySwatch, null);
  }

  return _react.default.createElement("div", _extends({
    className: classes,
    "data-test-subj": "colorSwatch",
    style: {
      background: color ? color : ''
    }
  }, rest), children);
};

exports.EuiColorPickerSwatch = EuiColorPickerSwatch;
EuiColorPickerSwatch.propTypes = {
  color: _propTypes.default.string
};
EuiColorPickerSwatch.__docgenInfo = {
  "description": "",
  "methods": [],
  "displayName": "EuiColorPickerSwatch",
  "props": {
    "color": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    }
  }
};