"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prettyInterval = prettyInterval;
var MS_IN_SECOND = 1000;
var MS_IN_MINUTE = 60 * MS_IN_SECOND;
var MS_IN_HOUR = 60 * MS_IN_MINUTE;
var MS_IN_DAY = 24 * MS_IN_HOUR;

function prettyInterval(isPaused, intervalInMs) {
  if (isPaused || intervalInMs === 0) {
    return 'Off';
  } else if (intervalInMs < MS_IN_MINUTE) {
    var intervalInSeconds = Math.round(intervalInMs / MS_IN_SECOND);

    var _units = intervalInSeconds > 1 ? 'seconds' : 'second';

    return "".concat(intervalInSeconds, " ").concat(_units);
  } else if (intervalInMs < MS_IN_HOUR) {
    var intervalInMinutes = Math.round(intervalInMs / MS_IN_MINUTE);

    var _units2 = intervalInMinutes > 1 ? 'minutes' : 'minute';

    return "".concat(intervalInMinutes, " ").concat(_units2);
  } else if (intervalInMs < MS_IN_DAY) {
    var intervalInHours = Math.round(intervalInMs / MS_IN_HOUR);

    var _units3 = intervalInHours > 1 ? 'hours' : 'hour';

    return "".concat(intervalInHours, " ").concat(_units3);
  }

  var intervalInDays = Math.round(intervalInMs / MS_IN_DAY);
  var units = intervalInDays > 1 ? 'days' : 'day';
  return "".concat(intervalInDays, " ").concat(units);
}