"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSecureRelForTarget = void 0;

require("core-js/modules/es6.array.sort");

require("core-js/modules/es6.regexp.split");

require("core-js/modules/es7.array.includes");

require("core-js/modules/es6.string.includes");

var _filter = _interopRequireDefault(require("lodash/filter"));

var _url = require("../url");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Secures outbound links. For more info:
 * https://www.jitbit.com/alexblog/256-targetblank---the-most-underestimated-vulnerability-ever/
 */
var getSecureRelForTarget = function getSecureRelForTarget(_ref) {
  var href = _ref.href,
      target = _ref.target,
      rel = _ref.rel;

  if (!target || !target.includes('_blank')) {
    return rel;
  }

  var isElasticHref = !!href && (0, _url.isDomainSecure)(href);
  var relParts = !!rel ? (0, _filter.default)(rel.split(' '), function (part) {
    return !!part.length && part !== 'noreferrer';
  }) : [];

  if (relParts.indexOf('noopener') === -1) {
    relParts.push('noopener');
  }

  if (!isElasticHref) {
    relParts.push('noreferrer');
  }

  return relParts.sort().join(' ').trim();
};

exports.getSecureRelForTarget = getSecureRelForTarget;